$title(MAC65/XL Cartridge  (c) 1988 ICD Inc)
$subtitle(Cartridge bank B for MAC65)
$include "equate.asm"
$include "tokens.asm"

	seg	bankb

;=================================
;	operator routines
;	-----------------
; note:
; special note:  all ops' addresses
; are all on the same page.
;
	db	-1	; so that high (symbol-1) are all on same page!!
@xtimes	jmp	xtimes	;  @xtimes is assumed to be first (for $if later!)
@xdiv	jmp	xdiv
@xmod	jmp	xmod


;	Addition
;	--------
@xplus	proc			; addition
	jsr	opop
	tay	
	txa	
	clc	
	adc	fr0
	sta	fr0
	 tya	
	 adc	fr0+1
	 sta	fr0+1
	rts	
	endproc


;	Minus and subtract
;	------------------
@xum	proc
	lda	#0		; unary minus
	tay			; a & y =0
	beq	..jsb		; join subtract

@xminus	jsr	opop		; subtraction
	tay	
	txa	

..jsb	sec	
	sbc	fr0
	sta	fr0
	 tya	
	 sbc	fr0+1
	 sta	fr0+1
	rts	
	endproc


;	Logical and
;	-----------
@xand	proc
	jsr	opop		; logical and
	and	fr0+1
	sta	fr0+1
	 txa	
	 and	fr0
	 sta	fr0
	rts	
	endproc


;	Equal and logical not
;	---------------------
@xceq	proc
	jsr	@xminus		; comp =
@xnot	lda	fr0+1		; not
	bne	falser
	lda	fr0
	bne	falser

truer	ldx	#1		; push true
sf1	lda	#0
sf0	sta	fr0+1
	stx	fr0
	rts	

falser	ldx	#0		; push false
	beq	sf1
	endproc


;	Not equal
;	---------
@xneq	proc
	jsr	@xminus		; comp <>
	lda	fr0+1
	bne	truer
	lda	fr0
	bne	truer
	beq	falser
	endproc


;	test label def
;	-------------
@xdef	proc
	ldy	#3		; tst label def
	lda	(srcadr),y
	and	#1
	eor	#1
	tax	
	lda	#0
	sta	res		; reset resolved
	beq	sf0
	endproc


@xorp	proc
	ldy	aptr		; right paren ]
	pla	
	pla	
	ldx	argops,y
	jmp	xs7
	endproc


;	Left paran
;	----------
@xelp	proc
	pla			; left "(" special
	pla			; pop return addr
	lda	fr0+1		; this is param #
	ldx	fr0
	jsr	valuep		; get actual value
	sta	fr0+1		; return to fr0
	stx	fr0
	jmp	xs9		; and continue
	endproc


;	Logical or
;	----------
@xorb	proc
	jsr	opop		; logical or
	ora	fr0+1
	sta	fr0+1
	 txa	
	 ora	fr0
	 sta	fr0
@xolp	rts			; left paren [
	endproc


;	Logical XOR
;	-----------
@xxor	proc
	jsr	opop		; logical eor
	eor	fr0+1
	sta	fr0+1
	txa	
	eor	fr0
	sta	fr0
	rts	
	endproc


;	Compare
;	-------
cmp	proc
	jsr	opop		; compare
	cmp	fr0+1
	bcc	cm0
	bne	cm0
	cpx	fr0
cm0	rts	
	endproc


;	comparison operators
;	--------------------
@xgrt	proc
	jsr	cmp		; greater than
	beq	@fl
	bcc	@fl
	bcs	@tr

@xls	jsr	cmp		; less than
	bcc	@tr
	bcs	@fl

@xleq	jsr	cmp		; less or equ
	beq	@tr
	bcc	@tr
	bcs	@fl
	endproc

;	BASIC and/or
;	------------
@xband	proc
	jsr	opop		; basic and
	stx	fr1		; low
	ora	fr1		; low or high (in a)
	beq	@fl
	bne	..xbj		; check high

@xbor	jsr	opop		; basic or
	stx	fr1
	ora	fr1
	bne	@tr
..xbj	lda	fr0
	ora	fr0+1
	bne	@tr
	beq	@fl
	endproc


;	Greater or equal
;	----------------
@xgeq	proc
	jsr	cmp		; greater or equ
	bcc	@fl

@tr	jmp	truer
@fl	jmp	falser
	endproc


;	High/low operator
;	-----------------
@xhigh	proc
	lda	fr0+1		; do high byte
	sta	fr0

@xlow	lda	#0		; do low byte
	sta	fr0+1
	rts	
	endproc


;	Reference
;	---------
@xref	proc
	ldy	#3		; label reference
	ldx	#0
	bit	eaf		; get pass #
	bvs	@2ref		; go if pass 2
	lda	mpf		; check mini 2
	bne	@2ref		; yup
	bit	res		; test referenced
	stx	res		; inhibit undefined
	bmi	@2ref		; not referenced
	jsr	s3by		; save 3 bytes
	bne	@tr		; unc

@2ref	lda	(srcadr),y	; see if ref
	stx	res		; inhibit undefined
	and	#$10		; in pass 1
	bne	@tr		; yup
	beq	@fl
	endproc


	$if (@xref-@xtimes) > 254
	 $error "operators not on same page"
	$endif

semd	proc
	lda	#0		; set up for
	sta	fr0+2		; mult & div
	sta	fr0+3
	ldy	#16
	rts	
	endproc


;	Multiply
;	--------
xtimes	proc
	jsr	opop		; multiply
	sta	fr1+1
	stx	fr1
	jsr	semd
..m1	lsr	fr0+3
	ror	fr0+2
	ror	fr0+1
	ror	fr0
	dey	
	bmi	..dv9		; all done
	bcc	..m1

	clc	
	ldx	#-2
..m2	lda	fr1+2,x
	adc	fr0+4,x
	sta	fr0+4,x
	inx	
	bne	..m2
	beq	..m1

xmod	jsr	xdiv		; modulo
	lda	fr0+2		; remainder is result
	sta	fr0
	lda	fr0+3
	sta	fr0+1
	rts	

xdiv	lda	fr0		; division
	sta	fr1
	lda	fr0+1
	sta	fr1+1
	jsr	opop
	sta	fr0+1
	stx	fr0
	jsr	semd
..dv1	asl	fr0
	rol	fr0+1
	rol	fr0+2
	rol	fr0+3
	sec	
	lda	fr0+2
	sbc	fr1
	tax	
	lda	fr0+3
	sbc	fr1+1
	bcc	..dv2
	sta	fr0+3
	stx	fr0+2
	inc	fr0
..dv2	dey	
	bne	..dv1
..dv9	rts	
	endproc



;	going on stack precedance
;	-------------------------
onprec	db $09		; +
	db $09		; -
	db $0a		; *
	db $0a		; /
	db $08		; &
	db $0f		; operator "("
	db $07		; =
	db $07		; <=
	db $07		; >=
	db $07		; <>
	db $07		; >
	db $07		; <
	db $0f		; - unary
	db $0f		; [
	db $04		; ]
	db $00,$00,$00
	db $08		; !
	db $08		; ^
	db $00
	db $0b		; \

;addressing mode type by terimator
; the next 8 bytes are an inbedded
; table, only .ref is used but not
; needed

endm	db 3		; ,x)      1 free
	db 2		; ),y        |
	db 6		; ,y         |
	db 5		; ,x         |
	db 4		; )          |
	db 7		; @comment   |
	db 7		; @eol     7 free
	db $fb		; @cma      .ref

	db $0f		; .def
	db $0f		; .not
	db $06		; .and
	db $05		; .or
	db $0f		; < low byte
	db $0f		; > high byte
	db 0,0,0,0,0,0,0,0,0


;	comming off precedance
;	----------------------
ofprec	db $09		; +
	db $09		; -
	db $0a		; *
	db $0a		; /
	db $08		; &
	db $01		; operator "("
	db $07		; =
	db $07		; <=
	db $07		; >=
	db $07		; <>
	db $07		; >
	db $07		; <
	db $0d		; - unary
	db $02		; [
	db $0e		; ]

; string displ table (3 bytes)
; ----------------------------
mstb	db $00,strmax,strmax*2
	db $08		; !
	db $08		; ^
	db $00
	db $0b		; \

;option mask table
; the next 8 bytes are an inbedded
; table, only .ref is used but not
; needed

opttab	db $40		; obj      1 free
	db $20		; err        |
	db $01		; eject      |
	db $80		; list       |
	db $02		; xref       |
	db $04		; mlist      |
	db $08		; clist    7 free
	db $10		; num       .ref

	db $02		; .def
	db $0d		; .not
	db $06		; .and
	db $05		; .or
	db $02		; < low byte
	db $02		; > high byte	CART version 1.01 this way
;	db $04		; > high byte	Steve's version like this
	db 0,0,0,0,0,0,0,0,0



;	operator tab low bytes
;	----------------------
opertrl	db	low @xplus-1	; +
	db	low @xminus-1	; -
	db	low @xtimes-1	; *
	db	low @xdiv-1	; /
	db	low @xand-1	; &  binary
	db	low @xelp-1	; operator "("
	db	low @xceq-1	; =  compare
	db	low @xleq-1	; <=
	db	low @xgeq-1	; >=
	db	low @xneq-1	; <>
	db	low @xgrt-1	; >
	db	low @xls-1	; <
	db	low @xum-1	; -  unary
	db	low @xolp-1	; [
	db	low @xorp-1	; ]
	db	0,0,0		; null entries
	db	low @xorb-1	; !  binary
	db	low @xxor-1	; ^ eor
	db	0		; ref null
	db	low @xmod-1	; \

;inbedded routine for .ref
; save 3 bytes (7 bytes long)

s3by	lda	#$10		; show referenced
	ora	(srcadr),y
	sta	(srcadr),y
	rts	

	db	low @xref-1	; .ref
	db	low @xdef-1	; .def
	db	low @xnot-1	; .not
	db	low @xband-1	; .and
	db	low @xbor-1	; .or
	db	low @xlow-1	; < low byte
	db	low @xhigh-1	; > high byte


;	execute directive tab
;	---------------------

xdirtb	dw	@@if-1
	dw	@@else-1
	dw	@@endif-1
	dw	@@macro-1
	dw	@@endm-1
	dw	@@title-1
	dw	@@macrox-1
	dw	@@page-1
	dw	@@word-1
	dw	@@error-1
	dw	@@byte-1
	dw	@@sbyte-1
	dw	@@dbyte-1
	dw	@@end-1
	dw	@@opt-1
	dw	@@tab-1
	dw	@@include-1
	dw	@@ds-1
	dw	@@aster-1
	dw	@@equal-1

	dw	@@bra-1
	dw	@@trb-1, @@trb-1

	dw	@@float-1
	dw	@@cbyte-1
	dw	@@semi-1
	dw	@@local-1
	dw	@@set-1
	dw	@@aster-1
	dw	@@equal-1, @@.equal-1
	dw	@@jsr-1, @@jmp-1


;	adr field tab
;	-------------
fldtab	db	0		; null
	db	$08		; immediate
	db	$10		; ind,y
	db	$00		; ind,x
	db	$10		; zp ind
	db	$14		; zp,x
	db	$14		; zp,y
	db	$04		; zero page
	db	$1c		; abs,x
	db	$18		; abs,y
	db	$0c		; absolute

	db	$08		; accumulator
	db	$00		; immediate
	db	0,0,0		; null  (3)
	db	$14		; zp,x
			; next 2 bytes are
trb0			;  for trb & tsb
	db	$14		; zp,y
	db	$04		; zero page
	db	$1c		; abs,x
	db	$1c		; abs,y
	db	$0c		; absolute


;	op tab
;	------
		; instr & type
@@cd	db $c6		; dec 2
	db $e6		; inc 2
	db $a6		; ldx 2
	db $a4		; ldy 2
	db @@sx		; stx 1
	db @@sy		; sty 1
	db $e4		; cpx 2
	db $c4		; cpy 2
	db $20		; bit 1

		; implied
	db $00		; brk
	db $18		; clc
	db $d8		; cld
	db $58		; cli
	db $b8		; clv
	db $ca		; dex
	db $88		; dey
	db $e8		; inx
	db $c8		; iny
	db $ea		; nop
	db $48		; pha
	db $08		; php
	db $68		; pla
	db $28		; plp
	db $40		; rti
	db $60		; rts
	db $38		; sec
	db $f8		; sed
	db $78		; sei
	db $aa		; tax
	db $a8		; tay
	db $ba		; tsx
	db $8a		; txa
	db $9a		; txs
	db $98		; tya

		; branch
	db $90		; bcc
	db $b0		; bcs
	db $f0		; beq
	db $30		; bmi
	db $d0		; bne
	db $10		; bpl
	db $50		; bvc
	db $70		; bvs

		; multi
	db $01		; ora 1
	db $21		; and 1
	db $41		; eor 1
	db $61		; adc 1
	db $81		; sta 1
	db $a1		; lda 1
	db $c1		; cmp 1
	db $e1		; sbc 1
	db $06		; asl 2
	db $26		; rol 2
	db $46		; lsr 2
	db $66		; ror 2

	db -1		; r65c02 instrs
	db $80		; bra (stz slot)
	db $3a		; dea
	db $1a		; ina
	db $da		; phx
	db $5a		; phy
	db $fa		; plx
	db $7a		; ply


;	instruction length table
;	------------------------
lentab	db 1,2,2,2
	db 2,2,2,2
	db 3,3,3


;	assembler portion
;	-----------------
_asmx:	proc
	ldx	#tosa-1		; set asm stack
	txs	
	jsr	asminit		; initialize
	lda	#$80		; set 1st pass
	sta	real		; master pass cntrl
	sta	eaf		; internal pass #

	jsr	gtokel		; test @eol
	beq	ax3		; yup, all set
	cmp	#@lcma		; a comma?
	beq	ax1		; yup, check list device

			; *** source file
	jsr	hfi		; open for read

	ldy	#low asmfm	; CART version!!
	jsr	hstr

	jsr	validf		; test check bytes
	jsr	donote		; 'note' start
	jsr	gtokel		; test @eol
	beq	ax3		; yup, go assemble

ax1	jsr	gtoke		; next token
	cmp	#@lcma		; a comma?
	beq	ax2		; yup, check object device

			;  *** list file
	cmp	#@minus		; inhibit list?
	bne	..opn		; must be a "#"
	lda	#$80		; master list control
	sta	klist
	bne	..il		; unc
..opn	jsr	opnout		; use list dev
..il	jsr	gtokel		; test @eol
	beq	ax3		; yup, all set

ax2	jsr	gtoke		; next token
	cmp	#@lcma		; comma?
	beq	axx		; do cross reference

			;  *** object file
	jsr	fobj		; use obj dev
			;  out binary file
	jsr	outff		; check bytes
	jsr	gtokel		; test @eol
	beq	ax3		; all set

			;   *** x-ref file
axx	inc	cox		; skip # sign
	jsr	mstrlitr	; filespec in table & lbuff
	jsr	fref		; now, cio stuff
	lda	asmram+2	; set initial addr
	ldx	asmram+3
	sta	bufferx
	sta	xrefbufi
	stx	bufferx+1
	stx	xrefbufi+1

	ldx	#asmram+2	; now, allocate it
	lda	#high bufsize /2
	ldy	#0
	jsr	expand

ax3	lda	#$40+$10	; no obj, no num
	ldy	objdv
	beq	..4
	lda	#$10		; no num
..4	ora	klist		; and master list
	sta	optflag

			; main loop
asml	jsr	asmline		; assemble a line
	jsr	wrtxref		; handle x-refs
	lda	eofflag		; end of pass?
	bpl	asml		; nope

	lda	sxref		; pop x-ref?
	beq	..rx		; no
	 sta	refdv		; restore x-ref

..rx	asl	real		; done assembling?
	bne	asme		; yup
	lda	#$40		; no, set pass 2
	sta	real
	sta	eaf
	jsr	reasm		; warm init

			;  out title, page...
	jsr	ppass
	beq	ax3		; unc, go do it!

asme	lda	refdv		; doing x-ref?
	beq	asmf		; no
	lda	#rfeof		; eof marker
	jsr	xrout
	jsr	rfwrite		; empty buffer
	lda	refdv
	jsr	closei		; close x-ref dev
	ldy	#3		; re-open as entdv
	lda	#4
	sty	entdv
	jsr	cio
	clc			; form filespec addr
	lda	smbltp
	adc	#6
	tay	
	lda	smbltp+1
	adc	#0
	jsr	io4.s		; do open

asmf	jsr	@@symbol	; do symbol table
nullx
asmexit:
	jsr	clsall		; close devices
	jsr	settab0		; reset list tabs
	jsr	reset		; reset pointers
	jmp	prmpt		; return to editor
	endproc



;	initialize assembler
;	--------------------
asminit	proc
	jsr	reset1
			;  start string space
	lda	asmram+2
	ldx	asmram+3
	sta	strings
	stx	strings+1
			;  set io buffer addr
	clc	
	adc	#low (strmax*3)
	sta	buffers		; lows
	sta	bufftab
	sta	bufftab+4
	sta	bufftab+2

	txa	
	adc	#high (strmax*3)
	sta	buffers+1
	sta	bufftab+1
	sta	bufftab+5
			;   buffersav addr
	clc	
	adc	#high bufsize
	sta	bufftab+3
			;    now, allocate area
	lda	#high ((bufsize*2) + (strmax*3))
	ldy	#low  ((bufsize*2) + (strmax*3))
	ldx	#asmram+2
	jsr	expand

	lda	#topform	; init top of form
	sta	topfc
	lda	#80		; right margin
	sta	rightmar
	lda	#66-8		; lines/page
			;   (physical size-heading)
	sta	formsz
	ldy	#0
	sty	lstdv		; clr all dev
	sty	entdv
	sty	objdv
	sty	refdv
	sty	leftmar		; left margin
	sty	klist		; master list on

	lda	#-1
	ldx	#55		; clear label pointers
..cst	sta	spointer,x
	dex	
	bpl	..cst

	lda	#$a0
	sta	asmfm		; main file list
	sta	(strings),y	; title string (y=0)
			;   expand macro stack
	lda	#1		; by 1 page (y=0)
	ldx	#stack+2
	jsr	expand

reasm	ldy	#1		; init to zero
	lda	#0		; parameters on stack
	sta	(stack),y
	 dey	
	 sta	(stack),y

	ldx	#1
..ccl	sta	asmpc,x		; pc
	sta	offset,x	; object offset
	sta	xrefsz,x	; x-ref file size
	sta	pagenum,x	; set pg # to 0
	sta	bytcnt,x	; byte count
	sta	lastl,x		; last line number

	$if xrindx = (sxref+1)
	  sty	sxref,x
	$endif
	$if eofflag = (pcdef+1)
	  sty	pcdef,x
	$endif
	$if eix = (epf+1)
	  sty	epf,x		; clr err indx
	$endif
	$if localix = (asmlino+2)
	  sty	asmlino+1,x	; auto-num
	$endif

	dex	
	bpl	..ccl
	stx	linecnt		; lines on page=-1
				;   y =0
	$if xrindx <> (sxref+1)
	  sty	xrindx		; x-ref buff index
	  sty	sxref		; no x-ref hold
	$endif
	$if eofflag <> (pcdef+1)
	  sty	pcdef		; pc def flg
	  sty	eofflag	; clr pass end
	$endif
	$if eix <> (epf+1)
	  sty	eix		; clr err indx
	  sty	epf		; v1.100 safety
	$endif
	$if localix <> (asmlino+2)
	  sty	localix		; first local field
	  sty	asmlino+1	; asm auto-num, hi
	$endif

	sty	curaug		; macro params
	sty	mpf		; mini-pass flag
	sty	inmac		; in-process macro
	sty	rstk		; run-time stk ptr
	sty	mcrsk		; macro stk ptr
	sty	errors		; assembly errors!

	lda	#$a0
	ldy	#strmax
	sta	(strings),y	; set pagep

	$if (strmax*2) = $a0
	  tay
	$else
	  ldy	#strmax*2
	$endif

	sta	(strings),y	; set usrmess
	sta	asmfi		; include file list

	lda	#low 100
	sta	asmlino
	lda	#4
	sta	setbyte		; set byte listing
	jmp	settab0		; go do tabs
	endproc


;	assemble a line
;	---------------
asmline	proc
	jsr	gscl		; get a line
	bcs	enpass		; br end of pass
	lda	#0
	sta	objix		; obj index
	sta	xrindx		; x-ref index
	jsr	gtoke
	beq	spp3		; error l.
	bpl	..nlab
	jsr	labint		; prefix label

	ldy	#2		; ck for label, eol
	lda	cox
	cmp	(exbuf),y
	bcs	spp9		; yup, go list
	jsr	gtoke
..nlab	cmp	#@scomment	; comment?
	beq	spp3		; yup
	jmp	opcode		; handle instr
spp9	jmp	putinbuff

			; set end of source status
enpass	bit	eofflag		; who issued eof
	bvc	true_		; not .include
	 lda	#0		; else, clr eof
	  db $2c
true_	lda	#$80		; set eof stat
	sta	eofflag
	jmp	write		; clean buffer
	endproc



;	list entry for non-code sorce
;	-----------------------------
; out:
;	result in fr0 for spp2
; spp1: label eol/*=/end/macro def
; spp2: .if and =,
; spp3: comment/error/command

spp1	proc
	bit	real		; really pass 1?
	bmi	spq		; yes
	jsr	spp0		; see if list
	bne	spq		; no
			;  fatal err list entry
sppr:	jsr	papc		; print asm pc +space
	lda	#11		; spaces
	bne	spcey		; now do line

spp2	bit	real		; really pass 1?
	bmi	spq		; yes
	jsr	spp0
	bne	spq		; as above
	lda	#4
	jsr	space		; do spaces
	lda	#'='		; do =
	jsr	charo
	ldy	fr0+1
	lda	fr0
	jsr	hexw		; pr result
	lda	#7
	bne	spcey		; pr 7 spaces

sp3er:	jsr	puterr		; list w/error

spp3:	bit	real		; really pass 1?
	bmi	spq		; yes
	jsr	spp0		; listing?
	bne	spq
	lda	#16		; sixteen spaces
spcey	jsr	spcez		; ck list macro
	jsr	asmlst		; list source
	jmp	tsterr		; ret thru here
	endproc



;	if in macro, out an "m" & do left margin
;	----------------------------------------
spcez	proc
spcem:	bit	inmac		; in macro?
	bpl	spceu		; nope

	sec	
	sbc	#1		; pop spaces by 1
	jsr	space		; and do 'em
	lda	#'M'		; do 'm
	jmp	charo		; ret
spceu	jmp	space		; just pad spaces
	endproc


tstlstm	proc
	lda	inmac		; active macro?
	beq	spq		; nope
	lda	optflag
	jsr	tstlss		; ck errs
	beq	spq		; err line, list
	lda	optflag		; ck macro list opt
	and	#4
spq	rts	
	endproc


;	test for list and eject (hairy!)
;	--------------------------------
spp0	proc
	jsr	tstlst
	bne	spd		; no listing
	jsr	tstlstm		; macro list
	bne	spd
	jsr	tstej		; test eject
	jsr	leftmr		; check left margin
spd	php	
	jsr	tstlstm		; macro line #
	beq	spb
	jsr	bckup
spb	plp	
	rts	
	endproc


;	reset asmlino
;	-------------
bckup	proc
	bit	eaf		; check pass #
	bmi	..b5		; still in #1
	ldy	#1		; if: in macrox &
..b6	lda	(exbuf),y	; opt = no mlist
	sta	asmlino,y
	dey			; reset asmlino
	bpl	..b6
..b5	rts			; ret <>0
	endproc



;	get a line from something
;	-------------------------
	proc
..abrk	jmp	asmexit
gscl	bit	brkkey		; break key?
	bpl	..abrk		; yup

	lda	entdv
	beq	memory
retry	ldy	#0		; set exbuf index
	sty	cox
	jsr	objx3		; get line # +offset
	bcs	eoof		; oops!
	adc	#-3		; sub 3; a =offset
	jsr	objx
	bcc	puteol		; sucess
eoof	sec	
	rts	

memory	lda	inmac		; inprocess macro?
	bmi	notxt		; don't test text end
	jsr	endl?
	bcs	eoof
notxt	ldy	#2
	lda	(stmcur),y
	tay	
	dey	
mvel	lda	(stmcur),y
	sta	(exbuf),y
	dey	
	bne	mvel
	lda	(stmcur),y
	sta	(exbuf),y

	jsr	gtadoff		; update "stmcur"
puteol	ldy	#2
	lda	(exbuf),y
	iny	
	sty	cox
	tay			; y returns with
	lda	#@eol		; line len
	sta	(exbuf),y
	bit	real		; pass 2?
	bmi	..wk1		; no

	lda	optflag		; num option
	and	#$10
	bne	..wk1		; no num

	sty	bfld		; safe temp for y
	ldy	#1
..wk2	lda	asmlino,y	; do auto num
	sta	(exbuf),y
	dey	
	bpl	..wk2
	inc	asmlino		; bump line num
	bne	..wk0
	 inc	asmlino+1

..wk0	ldy	bfld		; restore y
..wk1	clc	
	rts	
	endproc



;	print assembly end message
;	--------------------------
asmmess: proc
	jsr	tstej		; test eject
	jsr	tstejcr		; blank line
	jsr	leftmr		; handle left margin

	ldy	#high errasm
	ldx	#low errasm
	jsr	ptst
	ldx	errors
	jsr	pdnum0		; out # of errors
	jsr	space3		; spaces
	sec			; form free bytes
	lda	mtp
	sbc	memtop
	tax	
	 lda	mtp+1
	 sbc	memtop+1
	jsr	pdnum
	ldy	#high bytasm	; final message
	ldx	#low bytasm
	jmp	ptse		; ret thru
	endproc


;	branches
;	--------
@@bra	proc
	ldy	#@rockwell	; branch always
xbra	lda	@@cd-@dec,y	; get instr
	sta	tpobuf+1	; in obj buff
	jsr	xscan		; get result
	txa			; some malupation
	sec			; cal rel brnch
	sbc	asmpc
	tay	
	lda	fr0+1
	sbc	asmpc+1
	tax	
	tya	
	sec	
	sbc	#2
	sta	tpobuf+2	; operand in buff

	tay			; now, test range
	txa	
	sbc	#0
	bne	..xr1
	tya	
	bmi	..xr2
	bpl	..xr3
..xr1	tax	
	inx	
	bne	..xr2
	tya	
	bmi	..xr3

..xr2	lda	#3		; br range err
	jsr	puterrasm
..xr3	lda	#2
	sta	objix		; buffer size
	jmp	putinbuf0
	endproc



;	process mnenorics/directives
;	----------------------------
opcode	proc
	tay	
	cmp	#@dec		; directive?
	bcs	opc1		; no

	asl	a		; go execute directive
	tax	
	lda	xdirtb-@if*2+1,x
	pha	
	 lda	xdirtb-@if*2,x
	 pha	
	rts	

opc1	cmp	#@brk		; check for other types
	bcc	multi
	cmp	#@ora		; multi type
	bcs	mvlti
	cmp	#@bcc		; branch?
	bcs	xbra

aimp	lda	@@cd-@dec,y	; do implied type
	sta	tpobuf+1	; in obj buff
	lda	#1
	sta	objix		; buff size
	jmp	putinbuf0

			; test/reset bit instrs
@@trb	lda	trb0-@trb,y	; get base code
	pha			; and save
	jsr	xscan		; get addr
	pla	
	jmp	df2

mvlti	cmp	#@rockwell	; new instr?
	bcc	multi		; nope
	bne	aimp		; new implied type
			;  else, stz
	jsr	xscan
	lda	stzt-5,y	; get op
	sty	mode		; save mode
	jmp	finup		; unc


multi	lda	@@cd-@dec,y	; multi
	tax			; save inter-code
	and	#$e3		; get base code
	sta	bcode		; less adress field
	txa	
	and	#$1c		; which field?
	beq	fld1		; field 1
	 lda	#11
fld1	sta	bfld		; ofset to field 2
	jsr	gtoke		; test prefix adress
	cmp	#@a		; acc?
	bne	notac
	ldy	#0		; field indx acc
	beq	skk
notac	cmp	#@pnd		; immd?
	bne	cklp		; test (
	jsr	xscan		; scan exp
	ldy	#1
	bne	skk
cklp	cmp	#@lp		; for indirect
	beq	sk
	dec	cox		; adj indx
sk	jsr	xscan
skk	sty	mode		; y=mode
	cpy	#4		; was it (zp)?
	bne	skj		; no

	lda	bcode		; special ***
	and	#$f0		; save base
	ora	#2		; add new addr field
	bne	df1		; unc, go join

skj	clc	
	tya	
	adc	bfld
	tay	

	lda	bcode		; test special case op-codes
ckstxy	cmp	#@@sx		; is it stx?
	bne	ckstyy		; nope
	cpy	#9		; it ,y?
	bne	df1		; no
	ldy	#6		; reset to z-page
	bne	df2		; unc
ckstyy	cmp	#@@sy		; it sty?
	bne	ckzpy		; no
	cpy	#8		; it ,x?
	bne	df1		; no
	ldy	#5		; reset to z-page
	bne	df2		; unc
ckzpy	cpy	#6		; it zp,y?
	bne	df1		; no
	ldy	#9		; set to abs,y
df2	sty	mode		; store adressing mode
df1	ora	fldtab,y

finup	sta	tpobuf+1	; op code
	lda	fr0		; lo
	sta	tpobuf+2
	lda	fr0+1		; high
	sta	tpobuf+3
	ldy	mode		; instr len
	lda	lentab,y
	sta	objix
	cmp	#2		; test for legal
	bne	nzero
				;   a =2
	ldy	fr0+1
	beq	nzero		; z page ok
	iny			; try for $ff
	beq	nzero		; ok
	asl	a		; addr err (a =4)
	jsr	puterrasm	; asm vector
	lda	objix		; restore count
nzero	jmp	putinbuf0
	endproc



;	stz op codes
;	jmp addr fields
;	---------------

ijt	db $30,$20,-1	;jmp: ind,x  ind
;stzt	db $74,-1	;stz: zp,x  null	; steve's version!!
stzt	db $74,0	;stz: zp,x  null	; CART version!!!
	db $64,$9e	;stz: zp  abs,x
	db $00,$9c	;jmp: abs stz: abs


;	directive jsr & jmp
;	-------------------
@@jsr	proc
	lda	#$20		; base op code
..ii	pha			; save instr
	jsr	xscan		; get result
	sta	tpobuf+3	; high byte
	pla			; get instr
	ora	ijt-3,y		; for jmp
	sta	tpobuf+1	; opcode
	stx	tpobuf+2	; low byte
	lda	#3
	sta	objix		; size of instr
	jmp	putinbuf0

@@jmp	ldy	cox		; test for (
	lda	(exbuf),y
	cmp	#@lp
	bne	..ij
	 inc	cox		; skip the (
..ij	lda	#$4c		; get base code
	bne	..ii		; unc
	endproc



;	directives
;	db, .sbyte, .cbyte, .dbyte, .word
;	---------------------------------

@@cbyte	proc
	lda	#$40		; character bytes
	bne	setdrf

@@word	lda	#$80		; set reverse adress
	 db $2c
@@dbyte	lda	#$81		; set high/low adress
	ldx	#2		; list 2 bytes
	bne	setdr

@@sbyte	lda	#0		; screen adjust
	 db $2c
@@byte	lda	#1		; no screen adjust
setdrf	ldx	setbyte		; list format

setdr	stx	tpobuf		; list format
	sta	dirfg		; directive type

	lda	#0		; init modifier
	sta	modfybyt
	jsr	gtoke		; modifier?
	cmp	#@plus
	beq	evalm		; yes
	dec	cox		; pop exbuf index
	bne	eval		; unc

			; get modifier value
evalm	jsr	xscan		; get result
	stx	modfybyt	; and save it!

eval0	inc	cox		; past comma
eval	jsr	gtoke		; entry point
	cmp	#@qu		; string literal?
	beq	str@		; yup
	cmp	#@mstr		; macro string
	beq	strm@		; yup

	dec	cox
	jsr	xscan		; scan exp
	sty	commode		; save end status
	ldy	dirfg
	bmi	words		; two byte
	bne	..aj0
	 txa			; adj to screen
	 jsr	adjust		; code
	 tax	

..aj0	txa	
	jsr	object		; put in buff
	ldy	fr0+1		; test for byte
	beq	inrnge		; ok if =0
	iny			; other case
	beq	inrnge		; ok if =-1
	lda	#10		; val > 255 er
	jsr	puterrasm	; asm vector

inrnge	ldy	commode		; at end?
	bmi	eval0		; y minus if comma

bytend	lda	modfybyt	; do modifier
	beq	nomod		; skip if nothing
	ldy	objix
modloop	clc	
	lda	tpobuf,y
	adc	modfybyt
	sta	tpobuf,y
	dey	
	bne	modloop

nomod	jmp	putinbuff

words	cpy	#$81		; two byte process
	bne	dword		; it is word

	lda	fr0
	ldx	fr0+1
dword	pha	
	txa	
	jsr	object
	pla	
	jsr	object
	bne	inrnge		; unc go test nxt
	endproc


;	string bytes, literal
;	---------------------
str@	proc
	jsr	gtoke		; str literal
	and	#$7f		; str len
	tax	
jj8	jsr	gtoke
	ldy	dirfg		; screen code?
	bne	..aj1
	 jsr	adjust
..aj1	jsr	object
	dex	
	bne	jj8
	inc	cox		; past other "

			; is directive .cbyte?
strend	bit	dirfg		; .cbyte?
	bvc	..noc		; nope!
			;   y has index from "object"
			;   a has last byte too
	 eor	#$80		; toggle last string char
	 sta	tpobuf+1,y	; and store

..noc	jsr	endexp?
	tya			; y= - if comma
	bpl	bytend
	jmp	eval0		; another exp
	endproc


;	macro strings %$
;	----------------
strm@	proc
	dec	cox		; point back to %$
	jsr	xscan		; set srcadr adr
	ldx	#0		; string ofset
	lda	(srcadr,x)
	sta	temp
	ldy	#6
mmstr	lda	(srcadr),y	; move string
	sta	lbuff,x		; to lbuff
	inx	
	iny	
	cpy	temp		; done?
	bcc	mmstr		; move another

	cmp	#eol		; was last eol?
	bne	mvout		; no!

	dex			; strip the eol
mvout	stx	temp		; save length
	ldx	#0
..mob	lda	lbuff,x		; get the byte
	ldy	dirfg		; a screen byte?
	bne	..aj2		; no
	 jsr	adjust		; do screen code
..aj2	jsr	object		; out it
	inx	
	cpx	temp		; done?
	bcc	..mob		; no
	bcs	strend		; yup, unc
	endproc


;	adjust ascii to atari screen
;	----------------------------
adjust	proc
	tay			; set stat
	php			; save stat
	and	#$7f
	cmp	#'a'-1
	bcs	..f01
	cmp	#$20		; space
	bcc	..f00
	sbc	#$20
	 jmp	..f01

..f00	adc	#$40
..f01	plp			; get stat
	bpl	..f02
	 ora	#$80
..f02	rts	
	endproc



;	directive opt
;	-------------
@@opt	proc
	jsr	gtoke
	cmp	#@no		; negate option?
	beq	off@
	cmp	#@wait		; really x-ref
	bne	..ot
	ldx	sxref
	beq	..ot2		; nothing to restore
	stx	refdv

..ot	cmp	#@obj		; object?
	bne	..ot1
	 pha	
	 jsr	setobuf		; set obj buff
	 pla	
..ot1	cmp	#@err		; err?
	bne	..ot2
	ldy	#0		; clr err indx
	sty	eix
..ot2	tay	
	lda	opttab-@obj,y
	eor	#$ff
	and	optflag
	ora	klist		; master list control
	sta	optflag
	jmp	..ot4

off@	jsr	gtoke		; turn-off option
	cmp	#@wait		; really x-ref
	bne	oqt

	ldx	refdv		; save x-ref device
	beq	oqt		; don't over write
	stx	sxref
	ldx	#0		; and inhibit x-refs
	stx	refdv

oqt	cmp	#@obj		; object?
	bne	..ot3
	 pha	
	 jsr	write		; write cur buf
	 pla	
..ot3	tay	
	lda	opttab-@obj,y
	ora	optflag
	sta	optflag
..ot4	jsr	gtoke		; get nxt
	cmp	#@cma		; another option?
	beq	@@opt		; yup
	bne	..z5		; unc, go list


;	directive end
;	-------------
@@end	lda	entdv		; get dev
	bne	..z5		; ignore if dev
	 jsr	write		; out buffer
	 lda	#$80
	 sta	eofflag		; set eof
..z5	jmp	spp1
	endproc



;	set assembler system variable
;	-----------------------------
@@set	proc
	jsr	write		; for .set 6,exp
	jsr	xscan		; get id number
	txa	
	cmp	#sysmax		; illegal?
	bcc	..sys0		; nope
	 lda	#27		; invalid .set
	 jmp	sp3er

..sys0	pha			; save for later
	inc	cox		; skip comma
	jsr	xscan		; get set value
	pla			; get index
	tax			; save sys #
	lda	fr0		; get para 2
	cpx	#1
	beq	sysmar		; left margin, set 1
	bcc	sysbyte		; if set 0
	cpx	#4		; page size?
	bne	..sys1		; if not
			;   form size, set 4
	sbc	#8		; cs
	cmp	#20		; must be >20
	bcs	..sys1		; ok
	bcc	..sys3

sysbyte	tay			; byte format
	beq	..sys2
	cmp	#5
	bcc	..sys1
..sys2	lda	#4

sysmar	and	#$1f		; left margin
..sys1			;   just store sets
	sta	sysset,x
	cpx	#6		; set offset?
	bne	..sys3
	 lda	fr0+1
	 sta	sysset+1,x
	 jsr	setobuf		; set obj buff
	 jmp	spp2		; different list
..sys3	jmp	spp3


;	comment statements
;	------------------
@@semi	ldy	#3		; labeled line?
	lda	(exbuf),y
	bpl	..sys3		; no
	jmp	spp9		; list with label

;	.float directive
;	----------------
fmor	jsr	gtokel		; done or comma
	beq	..fd		; yup
	cmp	#@comment	; end of stmt?
	beq	..fd		; yup

@@float	jsr	gtoke		; string size
	jsr	processlaa	; move to lbuff
	lda	#eol		; term ascii #
	sta	lbuff,x
	lda	#0		; reset lbuff index
	sta	cix
	jsr	intlbf		; init lbuff

	ldx	#-6		; save conflicting ram
..scfr	lda	buffers+6,x
	pha	
	inx	
	bne	..scfr
	jsr	afp		; to floating point

	ldx	#5		; restore 'em now
..rcfr	pla	
	sta	buffers,x
	dex	
	bpl	..rcfr
	bcc	..fpg		; if legal
	 lda	#nfpr		; not floating point!
	 jsr	puterr

..fpg	ldx	#-6		; move to obj buff
..fpm	lda	fr0+6,x
	jsr	object
	inx	
	bne	..fpm		; if more...
	beq	fmor		; unc

..fd	lda	setbyte		; listing format
	jmp	putinbuf0	; list & return
	endproc


;	directive macrox
;	----------------
@@macrox proc
	jsr	gtoke		; handle name
	jsr	processlab
	lda	(srcadr),y	; defined?
	and	#4
	bne	c1		; yup

d4	lda	#nesm		; nesting error
	 db $2c
	lda	#udfm		; undef macro
	jmp	sp3er		; list w/error

c1	ldx	mcrsk		; get stk ptr
	cpx	#topsk		; at top of stk?
	bcs	d4		; yup

	lda	stmcur		; save next statement
	sta	svcur,x		; pointers for
	 lda	stmcur+1	; return
	 sta	svcur+1,x
	lda	entdv		; save enter dev
	sta	svedv,x
	lda	curaug		; save aug ptr
	sta	svaug,x

	txa			; cc from "c1"
	adc	#4		; update stack level
	sta	mcrsk

	ldy	#2
	lda	(srcadr),y	; get macro
	sta	stmcur+1	; exec adress
	 dey	
	 lda	(srcadr),y
	 sta	stmcur
	jsr	parset
	jsr	spp3		; list here
	jsr	wrtxref		; references

			; test & set pass 3
	lda	eaf		; ck asm pass #
	bmi	p0000		; br if pass 1
	bit	mpf		; ck mini-pass #
	bmi	p0000		; br if pass 3

	sta	mpf		; set mini pass 2
	asl	a
	sta	eaf		; set asm pass 1

	lda	asmpc		; save cur pc
	sta	svcpc
	 lda	asmpc+1
	 sta	svcpc+1
	lda	stmcur		; save macro start
	sta	svstm		; adress
	lda	stmcur+1
	sta	svstm+1

p0000	lda	#-1		; inprocess macro
	sta	inmac
	rts	
	endproc


;	set-up parameters & stack
;	-------------------------
parset	proc
	ldy	curaug		; get cur ptr
	lda	(stack),y	; para cnt of
	clc			; last macro
	adc	#1		; include %0
	asl	a		; four byte pushes
	asl	a
	adc	curaug		; plus pointer
	bcs	fnest1		; oops!

	sta	augx		; save curaug ptr
	tay	
	lda	#0
	sta	entdv		; get from mem

	sta	(stack),y	; init stack
	iny			; to zero
	sta	(stack),y	; parameters
	iny	
	lda	srcadr		; macro name
	sta	(stack),y	; adress
	iny	
	lda	srcadr+1
	sta	(stack),y
	iny	
	sty	tem0		; save pointer

parget	jsr	gtokel		; any parms?
	beq	pardone		; nope, all done
	cmp	#@comment
	beq	pardone		; nope, all done
	cmp	#@cma		; a comma?
	beq	parget		; yup, get next
	cmp	#@qu		; string literal?
	bne	parexp		; must be expression
	jsr	mstrlitr	; string literal
	beq	parstrv		; unc

fnest1	jmp	fnest		; fatal nest er

parexp	dec	cox		; pop index
	jsr	xscan		; get result
parstrv	pha			; save high byte
	txa	
	ldy	tem0		; get stack ptr
	sta	(stack),y
	iny	
	pla			; push hi byte
	sta	(stack),y
	iny	
	lda	srcadr		; mv string adress
	sta	(stack),y
	iny	
	 lda	srcadr+1
	 sta	(stack),y
	 iny			; point to next
	sty	tem0
	beq	fnest		; wrap-around!

	ldy	augx		; bump %0
	lda	(stack),y	; for this
	clc			; parameter
	adc	#1
	sta	(stack),y
	jmp	parget		; loop until done

pardone	lda	augx		; set new curaug
	sta	curaug
	rts	

fnest	lda	#nesm		; fatal nesting er
	jmp	abort

;	macro string literal
;	--------------------
mstrlitr
	jsr	gtoke
	jsr	processlaa	; set-up string
	lda	#eol		; tack eol to string
	sta	lbuff,x		; makes it unique!!

	inx			; bump indices
	inc	ltemp
	jsr	processla	; do label
	inc	cox		; skip other "

	ldx	ltemp		; get string literal
	dex			; length - eol
	lda	#0		; rtn length high, &
	sta	(svesa),y	; strings always defined
	rts	
	endproc


;	directive endm
;	--------------
@@endm	proc
	ldx	mcrsk		; get stk ptr
	beq	me1		; nesting err!
	dex			; pop stk ptr
	dex	
	dex	
	dex	
	bne	act		; mini pass still active

			;  mini-pass 3
	asl	mpf		; test end pass 3
	beq	act		; end pass 3
	lda	#$40		; reset asm pass 2
	sta	eaf
	lda	svcpc		; restore asmpc
	sta	asmpc
	 lda	svcpc+1
	 sta	asmpc+1
	lda	svstm		; pnt back to 1st
	sta	stmcur		; level macrox
	 lda	svstm+1
	 sta	stmcur+1
	lda	#0		; clr errs
	sta	eix
	rts	

act	stx	mcrsk
	lda	svcur+1,x	; restore old
	sta	stmcur+1	; pointers
	lda	svcur,x
	sta	stmcur
	lda	svaug,x
	sta	curaug
	lda	svedv,x
	sta	entdv

	jsr	spp3		; list
	lda	mcrsk		; at macro bottom?
	bne	..cd		; no
	 sta	inmac		; clear macrox
..cd	rts			; ret

me1	jmp	d4		; nesting err
	endproc



;	directive macro defination
;	--------------------------
@@macro	proc
	jsr	gtoke
	jsr	processlab	; macro name
	jsr	wrtxref		; references
	ldy	#3
	lda	(srcadr),y	; ck for dup
	ldx	eaf		; get pass #
	bpl	m0		; br if pass 2
	and	#4
	bne	ddf		; a dup macro def

	lda	#4		; define macro
	sta	(srcadr),y
	dey	
	lda	macend+1	; adress of start
	sta	(srcadr),y	; of macro exc
	dey	
	lda	macend
	sta	(srcadr),y

			;   read in rest of defination
m4	jsr	gscl		; get line
	bcc	m5		; br if not eof
..xlmr	lda	#lmr		; linked macro err
	jmp	abort

m5	sty	tem		; save line len
	ldx	#macend		; expand macro tab
	jsr	explow
	ldy	tem
m6	dey			; mv line to
	lda	(exbuf),y
	sta	(svesa),y	; defination
	tya			; table
	bne	m6

	jsr	gtoke		; look for .endm
	cmp	#@macro		; ck nested def
	beq	fnest2
	cmp	#@endm		; done?
	bne	m4
	rts	
fnest2	jmp	fnest

			; macro defination pass 2
			;  just list out defination
ddf	lda	#$14		; flag dup def
	sta	(srcadr),y
m0	and	#$10		; a dup def?
	beq	m2
	lda	#dupm		; tell user
	jsr	puterr
m2	jsr	spp3		; list this line
m8	jsr	gscl		; get nxt line
			;  this branch needed for a
			;  dup name and missing
	bcs	..xlmr		; .endm error!
	jsr	spp3		; and list
	jsr	gtoke		; look for .endm
	cmp	#@macro
	beq	fnest2
	cmp	#@endm
	bne	m8
	rts	
	endproc



;	directive = and .=
;	------------------
@@equal	proc
	sec			; *** flag as equate ***
	bcs	eqv

@@.equal
	clc			; *** flag as set ***
	lda	#0		; clear dup err
	sta	eix
eqv	lda	srcadr+1	; set "labpt"
	sta	labpt+1
	lda	srcadr
	sta	labpt
	bcc	eqe		; go if a set

	ldy	#3		; set primary undefined
	lda	(labpt),y
	ora	#1
	sta	(labpt),y

eqe	lda	mpf		; ck mini-pass
	beq	do		; if not mini-pass

			; do internal symbol processing
	ldx	ltemp		; get lab len
	lda	#'('		; assign type char
	sta	lbuff,x
	inc	ltemp		; bump lab len
	inx			; bump indx
	jsr	processla	; handle symbol

	lda	(srcadr),y
	bit	mpf		; get mini-pass #
	bmi	eqmp3		; br if pass 3
	and	#8		; lab already set?
	bne	do		; ye, normal process

			; assign expression to label & label(
	lda	#8
	sta	(srcadr),y	; set it
	jsr	pscan		; execute exp
	ldy	#1		; move value to
	txa	
	sta	(srcadr),y	; secondary label(
	iny	
	lda	fr0+1		; high
	sta	(srcadr),y
	jmp	dasgn		; assign to primary

			; re-assign to primary
eqmp3	and	#8		; lab reset?
	beq	do		; yup, go normal
	lda	#0
	sta	(srcadr),y
	jsr	pscan		; ex exp
	ldy	#1
	lda	(srcadr),y	; restore old
	tax			; result
	iny	
	lda	(srcadr),y
	sta	fr0+1		; so list is correct
	stx	fr0
	jmp	dasgn		; assign to primary


do	jsr	xscan		; get #
dasgn	ldy	#2
	sta	(labpt),y	; assign val
	txa	
	dey	
	sta	(labpt),y
	ldy	#3
	lda	(labpt),y
	and	#$fe		; clr poss undef
	ora	res		; set/rest def bit
	ora	#2		; set equated bit
	sta	(labpt),y
	jmp	spp2		; list

pscan	lda	srcadr		; save secondary
	pha			; label pointer
	lda	srcadr+1
	pha	
	jsr	xscan		; ex exp!
	pla			; restore pointer
	sta	srcadr+1
	pla	
	sta	srcadr
	rts	
	endproc


;	directive if
;	-----------
@@if	proc
	jsr	xscan		; eval exp
	ora	fr0		; test result
	php			; save stat
	jsr	wrtxref		; references
	jsr	spp2		; list line
	plp	
	beq	if1		; else or endif

	lda	#qelse		; else to stop
	jmp	rpush		; assembly

oops	lda	eofflag
	cmp	#$40		; ck end .include
	beq	rskmgr0		; if .inc, not end
	jmp	enpass

if1	lda	#qendif		; look for else or
	jsr	rpush		; endif to ret
	jmp	rskmgr		; go look for match

			; run-time stack handler
rskmgr0	lda	#0		; clear .include eof
	sta	eofflag

rskmgr	jsr	gscl		; get line
	bcs	oops		; encountered eof
	jsr	gtoke		; test this line
	bpl	rm7		; br if no label

	jsr	ifs		; skip past label
	jsr	gtoke		; next token
rm7	cmp	#@if		; nested if?
	bne	rm2		; nope

	lda	#qdumy		; push dummy type
	jsr	rpush

rm1	lda	optflag		; test condt option
	and	#8		; list conditional?
	beq	hclst		; yup!
	jsr	bckup
	bne	rskmgr		; unc

hclst	jsr	spp3		; list this line
	jmp	rskmgr		; get nxt

rm2	cmp	#@else		; it else?
	bne	rm3		; no
	ldy	rstk		; stack ptr
	lda	runstk,y	; get type
	beq	rm1		; br if dummy
	cmp	#qendif		; an exit?
	bne	rm4		; nest err
	lda	#qselse
	sta	runstk,y	; set else fnd
rm6	jmp	spp3		; list & ret

rm4	lda	#ntpe		; nesting err
	jsr	puterr
	jmp	rm1

rm3	cmp	#@endif		; terminal?
	beq	@@endif		; yup
	cmp	#@endm		; macro end?
	bne	rm1

	lda	inmac		; execute .endm only
	beq	rm1		; if doing macrox
	jsr	@@endm		; exec endm
	jmp	rskmgr
	endproc


;	directive endif
;	---------------
@@endif	proc
	ldy	rstk		; get cur ptr
	beq	rm5		; nesting err
	dec	rstk		; pop stack
	beq	rm6		; at bottom!

	lda	runstk,y	; make sure nxt
	beq	ee1		; isn't a dummy
	bne	rm6		; unc

rm5	lda	#ntpe		; nesting err
	jmp	sp3er
	endproc



;	directive else
;	--------------
@@else	proc
	ldy	rstk		; get stk ptr
	beq	rm5		; err!
	lda	runstk,y	; get type
	beq	rm6		; null
	cmp	#qselse		; else set?
	beq	rm5		; err!
ee1	jmp	rm1		; look for endif
	endproc



;	push to run-time conditions stk
;	-------------------------------
rpush	proc
	ldy	rstk
	iny	
	cpy	#skmx+1		; at top of stk?
	bcs	cp1		; yup, err
	 sta	runstk,y
	 sty	rstk
	 rts	
cp1	lda	#sofe		; stack overflow
	jmp	puterr		; and ret
	endproc



;	execute expression (rev 4/15/83)
;	--------------------------------
;	a = high, x = low, y = adrmode

xscan	proc
	ldy	#tose		; init stack
	sty	aptr
	lda	#@eol		; set pseudo end
	sta	argops,y
	ldy	#0
	sty	res		; clear resolved
	sty	optr		; init operator stack
	sty	topstk		; fr0 push flag

			; simple expression? (faster)
	jsr	getn		; try get value
	bcs	xs2		; no, an op
	stx	fr0		; possible result
	sta	fr0+1
	ldy	cox		; test end exp
	lda	(exbuf),y
	cmp	#@pcmax		; a terminator?
	bcs	quif		; yup, all done ***
	dec	topstk		; set push fr0 flag

			; not simple expression
xs9
xs1	jsr	getn		; get #
	bcs	xs2

	bit	topstk		; at top of stack?
	bpl	tsk
	pha			; push fr0 to stack
	ldy	optr
	lda	fr0+1
	sta	argops,y
	iny	
	lda	fr0
	sta	argops,y
	iny	
	sty	optr
	pla	
tsk	stx	fr0		; set new fr0
	sta	fr0+1
	dec	topstk
	jmp	xs1

xs2	sta	svop		; save oper
	tax	
	lda	onprec-@plus,x
	sta	svnp		; save precedance
xs8	ldy	aptr
	ldx	argops,y	; get old
	lda	ofprec-@plus,x
	cmp	svnp
	bcc	xs3		; push oper
	tay	
	beq	quit		; done
xs7	inc	aptr
	jsr	xs4
	jmp	xs8
	endproc


;	execute operator
;	----------------
xs4	proc
	lda	#high (@xplus-1)
	pha	
	 lda	opertrl-@plus,x
	 pha	
	rts	
	endproc


xs3	proc
	lda	svop		; push operator:
	dey			; bump index
	cpy	optr		; stack overflow?
	bcc	quitr		; yup!!
	 sta	argops,y	; ok, so save it
	 sty	aptr
	 jmp	xs1

quitr	lda	#6		; exp complex err
	jsr	puterrasm
	jmp	quit

quif	inc	cox		; adjust cox, fast exit
quit	lda	res		; exp resolved?
	beq	xs5		; yup
	lda	#5		; else, undef error
	jsr	puterrasm

xs5	dec	cox		; pop index
	ldy	cox		; get adressing mode
	lda	(exbuf),y
	tax	
	ldy	endm-@pcmax,x	; mode in y

			; determind absolute or z page
noudf	ldx	fr0		; res low
	lda	fr0+1		; res hi
	ora	res		; force non z page
	beq	exx0		; z pg anyway
	cpy	#5		; non z instr?
	bcc	exx0		; no
	iny			; bump mode to abs
	iny	
	iny	
exx0	lda	fr0+1		; restore high byte
	rts	
	endproc



;	pop entry from argops
;	---------------------
opop	proc
	ldy	optr		; get stack pointer
	dey			; pop index
	ldx	argops,y	; get low byte in x
	dey			; pop index
	lda	argops,y	; get high byte
	sty	optr		; save new pointer
	rts	
	endproc


;	get num, a = high; x = low  cc
;       a = operator token cs
;	------------------------------
getn:	proc
	ldy	cox		; get next token
	inc	cox
	lda	(exbuf),y
	bmi	issymb		; branch if label
getne:	cmp	#@apost+1	; other type?
	bcs	gn1		; yup, go test
nomp	lsr	a		; status: word or byte
	ldy	cox		; get low byte
	inc	cox
	lda	(exbuf),y
	tax			; in x
	bcs	gn2		; if carry, then get high
	lda	#0		; else, high =0
	rts	
gn2	clc			; set no-operator status
	jmp	gtoke		; get high

gn1	cmp	#@cpc		; pc?
	beq	dopc
	bcc	domp		; do macro param
	rts			; cs =operator

dopc:	clc	
	lda	asmpc
	adc	objix		; add in cur
	tax	
	lda	asmpc+1
	adc	#0
	rts			; return, carry is clear

			; process symbol
issymb	jsr	processlab	; v1.103
	lda	(srcadr),y	; defined byte
	bcc	yesdf		; go if not newly inserted
	 lda	#$81		; special for .ref
	 clc 	
	 bcc	yesrf		; unc

yesdf	and	#1		; just move status
	ora	res		; to resolved flag

yesrf	sta	res
	ldy	#1		; get value
	lda	(srcadr),y
	tax	
	iny	
	lda	(srcadr),y
	rts			; carry is clear
	endproc



b2	proc
	lda	#32		; bad parameter
	jsr	puterr		; err & ret
	lda	#0		; ret zero
	tax	
	clc	
	rts	
	endproc


;	get parameter from a macro call
;	-------------------------------
domp	proc
	jsr	gtoke
	cmp	#@lp		; is it %(exp)?
	bne	b4		; nope
	 lda	#@elp		; special operator
	 rts			; carry set

b4	jsr	nomp		; get param #
valuep	cmp	#0		; no param >255
	bne	b2		; val > 255
	txa	
	ldy	curaug		; get aug pointer
	cmp	(stack),y	; test param range
	beq	b3
	bcs	b2		; out of range

b3	ldx	mcrsk		; ck for zero stk
	beq	b2
	asl	a		; form stack indx
	asl	a		; multiples of 4
	clc			; as offset from
	adc	curaug		; cur aug ptr
	tay			; x
	lda	(stack),y	; get low
	iny	
	tax	
	lda	(stack),y	; get high
	pha			; save high
	iny	
	lda	(stack),y	; string adress
	sta	srcadr
	iny	
	lda	(stack),y
	sta	srcadr+1

	ldy	#3		; get defined stat
	lda	(srcadr),y
	ora	res
	and	#1		; out other stuff
	sta	res
	pla			; restore high
	clc	
	rts	
	endproc



;	test for exp end:
;	 cs = end, y = adr mode
;	 cc = operator, or number type
;	------------------------------
endexp?	proc
	ldy	cox		; get token
	lda	(exbuf),y
	cmp	#@pcmax		; tst first term
	bcs	endp		; br if terminal
	rts			; an operator

endp	tax			; indx to mode tab
	bmi	b1		; test for label
	ldy	endm-@pcmax,x	; get mode in y
	rts	
b1	clc	
	rts	
	endproc



;	process labels
;	--------------
; returns y=3
; pointing to define byte

processlaa proc
	and #$7f		; lab len
	sta	ltemp		; sav
	ldx	#0		; clr indx
	ldy	cox
labloop	lda	(exbuf),y	; move to
	sta	lbuff,x		; text buff
	inx	
	iny	
	cpx	ltemp
	bcc	labloop
	sty	cox		; point to nxt
	rts	
	endproc


processlab proc
	jsr processlaa
	lda	lbuff		; check local

	$if sorcim
	 cmp	#':'
	 bne	..rc1
	  lda	#'?'
	  sta	lbuff
..rc1	 ldy	lbuff-1,x	; last a ":"?
	 cpy	#':'
	 bne	..rc2
	 dex		; ignore the colon
	 dec ltemp
..rc2
	$endif

	cmp	#'?'
	bne	processla	; nope

	lda	localix
	beq	processla	; first unchanged
	 sta	lbuff		; do local counter

processla
	txa			; form exp size
	clc	
	adc	#6
	sta	labof

			; get label character address
	lda	lbuff		; set-up
	cmp	#'?'		; less, use "?"
	bcs	limith
	 lda	#'?'
	 bne	getaddr		; unc
limith	cmp	#'Z'+1		; test top
	bcc	getaddr
	 lda	#'Z'

getaddr	asl	a		; double index
	tax	
	ldy	spointer-'?'*2+1,x	; high
	bmi	newlabel		; yup, a first

				; search loop
	lda	spointer-'?'*2,x	; low
nextlink
	clc	
	adc	smbltp		; add in absolute
	sta	srcadr
	 tya	
	 adc	smbltp+1	; add in high
	 sta	srcadr+1

	ldx	#0		; compare offsets
	lda	labof
	cmp	(srcadr,x)
	bne	testlink

	ldy	#6		; do characters
sy1	lda	(srcadr),y
	eor	lbuff-6,y
	beq	sy2		; a match

testlink
	ldy	#4		; get link low
	lda	(srcadr),y
	tax	
	iny	
	lda	(srcadr),y
	tay	
	txa	
	cpy	#-1
	bne	nextlink
	beq	nointab

sy2	iny	
	cpy	labof
	bcc	sy1
	 clc	
	 jmp	rightone
	endproc


;	insert symbol in table
;	----------------------
; x is index to "spointer"

newlabel proc
	lda	smblend
	sta	srcadr		; set 'srcadr'
	sec	
	sbc	smbltp		; 'spointer' entry
	sta	spointer-'?'*2,x	; link
	 lda	smblend+1
	 sta	srcadr+1
	 sbc	smbltp+1
	 sta	spointer-'?'*2+1,x	; high

nointab	lda	smblend		; set "svesa"
	sta	svesa
	clc			; add low expand
	adc	labof
	 tay			; for mem test
	 lda	smblend+1
	 sta	svesa+1
	 adc	#0

	cmp	mtp+1		; within?
	bcc	esafe
	cpy	mtp		; low within?
	bcc	esafe		; yes
	beq	esafe
	jmp	exxi		; out of memory

esafe	sta	smblend+1
	sty	smblend

			;  link this entry to last entry
			;   "srcadr" points to last
	ldy	#4		; subtract "smblpt"
	sec	
	lda	svesa
	tax	
	sbc	smbltp
	sta	(srcadr),y
	 iny	
	 lda	svesa+1
	 sbc	smbltp+1
	 sta	(srcadr),y

	lda	svesa+1		; make "svesa"="srcadr"
	sta	srcadr+1
	stx	srcadr

	ldy	#0
	lda	labof		; offset to nxt lab
	sta	(svesa),y
	tya			; a =0
	iny			; y =1
	tax			; x =0
	sta	(svesa),y	; zero adress
	iny	
	sta	(svesa),y
	lda	#1
	iny	
	sta	(svesa),y	; set undef

	iny			; set last label link
	iny	
	lda	#-1
	sta	(svesa),y	; high byte is flag

mvelp	iny			; move symbol
	lda	lbuff,x
	sta	(svesa),y
	inx	
	cpx	ltemp		; past last one?
	bcc	mvelp		; no, get next
rightone
	lda	refdv		; build x-ref?
	bne	buildrf		; yup
	ldy	#3
	rts	


			; build x-reference data
buildrf	php			; save carry
	bit	eaf		; pass 2?
	bvc	noxloc		; no
	ldy	#6
	lda	(srcadr),y	; is it a local?
	cmp	#'?'+1

	$if dolocal
	  bcs	noxloc		; only locals
	$else
	  bcc	noxloc		; yup
	$endif

	ldx	xrindx		; buffer full?
	cpx	#xrmax+1
	bcs	xrfer		; yup

	sec	
	lda	srcadr
	sbc	smbltp		; dump table link
	sta	xrefbuf+1,x	; format:
	lda	srcadr+1	; high/low
	sbc	smbltp+1
	sta	xrefbuf,x

			; already referenced?
	ldy	xrindx
duprfx	dey			; pop to last entry
	dey	
	bmi	newrfx		; no match, new entry
	lda	xrefbuf,y	; high
	cmp	xrefbuf,x
	bne	duprfx		; try next entry
	lda	xrefbuf+1,y
	cmp	xrefbuf+1,x
	bne	duprfx		; next entry
	beq	noxloc		; don't update index

newrfx	inx			; point to next
	inx	
	stx	xrindx
noxloc	ldy	#3
	plp			; get carry status
	rts	

xrfer	lda	#xrerr		; too many x-refs
	jsr	puterr
	jmp	noxloc
	endproc



;	label at start of line
;	----------------------
labint	proc
	jsr	processlab
	lda	(srcadr),y
	and	#$fe		; clr undef bit
	pha			; save
	bmi	lt1		; already there
	lda	asmpc+1		; define it
	dey	
	sta	(srcadr),y
	lda	asmpc
	dey	
	sta	(srcadr),y
	jmp	lt3

lt1	and	#2		; equated?
	bne	lt3		; yes
	lda	asmpc+1		; must match pc
	dey	
	cmp	(srcadr),y
	bne	lt2
	lda	asmpc
	dey	
	cmp	(srcadr),y
	beq	lt3		; ok
lt2	lda	#13		; phase error
	jsr	puterrasm
lt3	pla			; get define byte
	pha	
	asl	a
	bpl	lt4
	 lda	#7		; duplicate label
	 jsr	puterrasm
lt4	ldy	#3
	pla	
	bit	inmac		; in macro exec?
	bpl	lt6		; no, regular lab

	tax			; def byte must =0
	beq	lt5		; don't set flag

lt6	ora	eaf		; set pass #
lt5	sta	(srcadr),y
	lda	refdv		; doing x-ref?
	beq	lt7		; no
	bit	eaf		; only if pass 2
	bmi	lt7
	bit	lbuff		; locals will clear v

	$if dolocal
	  bvs	lt7
	$else
	  bvc	lt7		; don't flag
	$endif

	lda	#rflab		; flag labeled line
	jsr	xrout
lt7	rts	
	endproc



@@local	proc
	inc	localix		; tough!!
	lda	localix		; get fancy...
	cmp	#'?'		; at max?
	bcc	lsafe		; yup
	lda	#hlocer		; tell user
	jsr	puterr
	lda	#'?'

lsafe	sta	fr0
	lda	#0
	sta	fr0+1
	jmp	spp2		; list & return
	endproc


;	directive title
;	---------------
@@title	proc
	ldx	#0		; string statement
	jsr	msrg
	bne	..pp0		; unc

;	directive error
;	---------------
@@error	ldx	#2
	jsr	msrg
	lda	#0		; force error "0"
	jsr	puterrasm
..pp0	jmp	spp3
	endproc




;	put .page, .title, & .error strings in memory
;	---------------------------------------------
msrg:	proc
	jsr	gtoke
	cmp	#@qu		; string?
	beq	g0		; yup
	rts	

g0	clc	
	lda	strings
	adc	mstb,x
	sta	srcadr
	lda	strings+1
	adc	#0
	sta	srcadr+1
	jsr	gtoke7		; get str len
	tax	
	lda	#0
	sta	temp
	cpx	#strmax+1	; check length
	bcc	ptmov
	ldx	#strmax

ptmov	jsr	gtoke7		; get 7 bit char
	ldy	temp
	inc	temp
	sta	(srcadr),y	; to buffer
	dex	
	bne	ptmov
	ora	#$80		; flag last char
	sta	(srcadr),y
	rts	
	endproc



;	directive tab
;	-------------
@@tab	proc
	jsr	xscan		; get first #
	stx	tab1
	inc	cox		; skip ,
	jsr	xscan		; get second #
	stx	tab2
	inc	cox		; skip ,
	jsr	xscan		; get third #
	stx	tab3
	jsr	setztab		; reset zp tabs
	jmp	spp3		; go list
	endproc



;	test for save file & pop file size
;	----------------------------------
validf:	proc
	jsr	gobj		; test ck byte
	cmp	#ckbyt
	bne	ifail		; oops!
	jsr	gobj		; test ck byte
	cmp	#ckbyt
	bne	ifail		; oops!

popsizef:
	jsr	gobj		; file size
	sta	filesize
	jsr	gobj
	sta	filesize+1	; store & return
	rts	

ifail	lda	#23		; not save error
stopasm	jmp	abort
	endproc


;	directive ds
;	------------
@@ds	proc
	jsr	xscan		; get number
	bit	pcdef		; pc defined?
	bpl	..ae9		; no!
	txa			; calculate new pc
	clc	
	adc	asmpc
	tax			; low in x
	lda	fr0+1
	adc	asmpc+1
	jmp	..ae0		; join *=

;	directive *=
;	------------
@@aster	jsr	xscan		; get num
..ae0	ldy	res		; defined?
	beq	..ae1		; yup
..ae9	lda	#14		; stop!
	bne	stopasm

..ae1	dey			; set y =$ff
	sty	pcdef		; set pc defined
	bit	eaf		; get pass #
	bpl	..ae2		; branch if pass 2
	sta	asmpc+1		; else, just set new
	stx	asmpc		; pc adress
	jmp	spp1		; all done

..ae2	pha			; save new pc
	txa	
	pha	
	jsr	write		; write, if any
	jsr	spp1		; list line
	pla			; get new pc
	sta	asmpc
	pla	
	sta	asmpc+1
	jmp	setobuf		; set obj pc & return
	endproc



;	writes object to device
;	-----------------------
write:	proc
	lda	objptr
	cmp	#4		; test null
	beq	..empt
	sec	
	sbc	#5		; for end adress
	clc			; compute end adress
	ldy	#0
	adc	(objbuf),y
	ldy	#2
	sta	(objbuf),y
	dey	
	lda	(objbuf),y
	adc	#0
	ldy	#3
	sta	(objbuf),y
	pha			; save end adress
	dey	
	lda	(objbuf),y
	pha	

	jsr	runout		; write it
	pla	
	clc			; set new start adress
	adc	#1

			; high byte on stack, carry
			; must be clear at entry
..sovx	ldy	#0
	sta	(objbuf),y
	pla	
	adc	#0
	iny	
	sta	(objbuf),y
	ldy	#4		; reset pointer
	sty	objptr
..empt	rts	


;	set up object buffer
;	--------------------
setobuf
	lda	asmpc
	clc	
	adc	offset
	tax	
	lda	asmpc+1
	adc	offset+1
	pha	
	txa	
	clc	
	bcc	..sovx
	endproc
