$title(MAC65/XL Cartridge  (c) 1988 ICD Inc)
$subtitle(Misc segamnets for MAC65)
$include "equate.asm"

	seg	switch
;====================================
;	Bank switching vectors
;====================================

;	call listerr
;	------------
listerr: proc
	lda	romf+$0fff	; get bank #
	pha			; & save
	sta	bank1		; get list bank
	jsr	_listerr	; do it
	pla	
	tax	
	sta	bank1,x
	rts	
	endproc


;	call asm
;	--------
asmx:	proc
	sta	bank2
	jmp	_asmx
	endproc


;	editor get numbers
;	------------------
_getne:	proc
	sta	bank2
	jsr	getne
	jmp	..j

_getn:	sta	bank2
	jsr	getn
..j	sta	bank1
	rts	
	endproc



$eject
	seg	carvec		; cart vectors at $BFFA
;=====================================
;	Cartridge vector point
;	----------------------
	dw	cart
	db	0
	db	$05
	dw	carti


;========================================
;	Cartridge bank identifiers
;	--------------------------
	seg	banka_v
	db	bank1 & 15

	seg	bankb_v
	db	bank2 & 15

	seg	bankc_v
	db	bank3 & 15


$eject
	seg	copy_right
;=================================
;	Copyright message
;=================================
mes:	db	$7d,'MAC/65',tab,tab, 'Version 1.0',$B1
mes1	db	'(c) 1984 Stephen D. Lawrow, OSS, Inc', $AE
	db	$7F

dos:	jmp	(dosvec)



$eject
	seg	initial
;==================================================
;	Initz and cold/warm cart entry points
;==================================================
	jmp	warm		; warm entry without car

;	cartridge init
;	--------------
carti	proc
	lda	coldst		; power-up?
	beq	..ci		; nope!
	lda	#$ca		; set up default colors
	sta	colors
	lda	#$94
	sta	colors+1
	lda	#cntrlc		; abort=control-c
	sta	hcntrlc

cartrtn:
	lda	#high xcio	; set (cio)
	sta	xcii+1
	lda	#low xcio
	sta	xcii
..ci	$if cbug
	 nop
	$else
	 rts
	$endif
	endproc


;	cartridge run
;	-------------
cart	proc
	sta	bank1		; enable syntax bank
	$if ddt?
	 ldx	warmflg		; cartridge cold?
	 beq	..ddt		; yup, don't check ddt
	 lda	zpsflg		; in ddt?
	 bne	..ddt		; nope
	 jmp	ddtwrm
..ddt
	$endif

	cld			; clear dec mode
	cli			; enable interrupts
	ldx	#-1		; set stack
	txs	
	stx	brkkey		; clear break key
	inx			; x=0  list to e:
	stx	lstdv
	stx	entdv		; enter dev =0
	stx	eaf		; set edit mode

;	$if (low mes) <> 0	; CAUTION assume that MES starts at page bound
;	 ldx	#low mes	; print start-up msg
;	$endif

	jsr	ptsc		; at cart entry
	ldx	#low mes1	; part 2 of msg
	jsr	ptsc

;	$if (high mes) <> (high mes1)	; CAUTION assume that MES and MES1 on
;	 $error "start-up msg error"	;  same page!
;	$endif

	lda	warmflg		; cart cold start?
	bne	warm		; nope!
	 jsr	init		; set mem ptrs & edit mode
	endproc


;	warm start
;	----------
warm:	proc
	jsr	settab		; set list tabs
	jsr	reset		; init some vars

prmpt:	lda	#3		; enable keyboard
	sta	skctl
	sta	bank1
	jsr	docr
	ldx	#low edit	; print prompt
	ldy	#high edit
	bit	txtflag		; we in text mode?
	bpl	..wrm0		; nope
	 ldx	#low txtmd	; else, print text:

;	$if (high txtmd) <> (high edit)
;	 ldy	#high txtmd
;	$endif

..wrm0	jsr	ptse
	lda	colors		; set color
	sta	color1
	lda	colors+1
	sta	color2

noprm:	sta	bank1		; syntax bank
	ldx	#4		; set tabs!
..wrm1	lda	oss,x
	sta	tabmap,x
	 dex	
	 bpl	..wrm1

	txs			; set stack
	inx			; x=0
	stx	epf		; clear rep mode
	stx	eaf		; set edit mode
	stx	dspflg		; display ctrl chars
	stx	cpad		; comment pad=0
	jsr	sd1		; no sound
	jsr	input		; get line of input
	bne	noprm		; br if break key

very:	jsr	lnum?		; numed line?
	bcs	pedit		; no, try command
	 jmp	ptext		; process text
	endproc


;	process editor command
;	----------------------
pedit	proc
	jsr	konvert		; fix case
	jsr	skpspace
	ldx	#2		; go search
	lda	#high command	; command table
	ldy	#low command
	jsr	search
	bcs	what		; no good!

	stx	cix		; new text index
	lda	svf2		; table entry
	pha			; save for exec
	ldy	#0		; get syntax adr
	lda	(srcadr),y	; from keyword table
	sta	saxpc
	iny	
	lda	(srcadr),y
	sta	saxpc+1
	jsr	stc		; syntax it
	pla			; pop table entry
	bcs	what		; abort if bad
	jsr	exec		; execute
	jmp	prmpt		; and re-prompt
what	jmp	_what		; print "what!"
	endproc



;	cold start initialization
;	-------------------------
init	proc
	ldx	memlow		; get lomem
	stx	svlomem		; and save
	ldx	memlow+1
	stx	svlomem+1

;	editor new
;	----------
newx:	lda	#0		; new clears
newtxt:	sta	txtflag		; text mode

enttxt:	ldx	svlomem		; set lomem
	ldy	svlomem+1
	stx	lomem
	sty	lomem+1
	iny			; for exbuff
	txa			; x
	ldx	#objbuf		; set other ptrs
	jsr	cs1
	ldx	#txttab		; expand by 256
	ldy	#0		; for obj buff
	lda	#1
	jmp	expand		; expand & return
	endproc


;	clean-up for return to editor
;	-----------------------------
reset:	proc
	lda	#0
	ldx	#group
..rss	sta	eaf,x		; clear all key
	dex	
	bpl	..rss

			; reset upper pointers
reset1:	ldx	#txtend+2
	lda	txtend
	ldy	txtend+1	; fall to cs1

			; init table pointers
cs1:	sta	0,x		; set adr low
	inx	
	sty	0,x		; set adr high
	inx	
	cpx	#memtop+2	; at limit?
	bcc	cs1
	sty	aphm+1		; and aphmi
	sta	aphm
	rts	
	endproc
